Index: typo3/sysext/rtehtmlarea/ext_conf_template.txt
===================================================================
--- typo3/sysext/rtehtmlarea/ext_conf_template.txt	(révision 10447)
+++ typo3/sysext/rtehtmlarea/ext_conf_template.txt	(copie de travail)
@@ -10,12 +10,6 @@
   # cat=basic; type=string; label=Aspell path: The server path where Aspell is installed.
 AspellDirectory = /usr/bin/aspell
 
-  # cat=basic; type=string; label=Default Aspell dictionary: The default dictionary to be used by the htmlArea SpellChecker plugin. DEPRECATED. Use Page TSConfig properties defaultContentLanguage and buttons.spellcheck.dictionaries.[language-iso-code].defaultValue.
-defaultDictionary = en
-
-  # cat=basic; type=string; label=List of Aspell dictionaries: The list of dictionaries available to the htmlArea SpellChecker plugin. DEPRECATED. Use Page TSConfig properties buttons.spellcheck.dictionaries.items and restrictToItems.
-dictionaryList  = en
-
   # cat=basic/enable/100; type=options[Minimal (Most features disabled. Administrator needs to enable them using TypoScript. For advanced administrators only.),Typical (Most commonly used features are enabled. Select this option if you are unsure which one to use.),Demo (Show-off configuration. Includes pre-configured styles. Not for production environments.)]; label=Default configuration settings
 defaultConfiguration = Typical (Most commonly used features are enabled. Select this option if you are unsure which one to use.)
 
Index: typo3/sysext/rtehtmlarea/ext_localconf.php
===================================================================
--- typo3/sysext/rtehtmlarea/ext_localconf.php	(révision 10447)
+++ typo3/sysext/rtehtmlarea/ext_localconf.php	(copie de travail)
@@ -208,9 +208,6 @@
 $TYPO3_CONF_VARS['EXTCONF'][$_EXTKEY]['plugins']['SpellChecker']['AspellDirectory'] = $_EXTCONF['AspellDirectory'] ? $_EXTCONF['AspellDirectory'] : '/usr/bin/aspell';
 $TYPO3_CONF_VARS['EXTCONF'][$_EXTKEY]['plugins']['SpellChecker']['noSpellCheckLanguages'] = $_EXTCONF['noSpellCheckLanguages'] ? $_EXTCONF['noSpellCheckLanguages'] : 'ja,km,ko,lo,th,zh,b5,gb';
 $TYPO3_CONF_VARS['EXTCONF'][$_EXTKEY]['plugins']['SpellChecker']['forceCommandMode'] = $_EXTCONF['forceCommandMode'] ? $_EXTCONF['forceCommandMode'] : 0;
-	// The following two properties DEPRECATED as of TYPO3 4.3.0
-$TYPO3_CONF_VARS['EXTCONF'][$_EXTKEY]['plugins']['SpellChecker']['dictionaryList'] = $_EXTCONF['dictionaryList'] ? $_EXTCONF['dictionaryList'] : 'en';
-$TYPO3_CONF_VARS['EXTCONF'][$_EXTKEY]['plugins']['SpellChecker']['defaultDictionary'] = $_EXTCONF['defaultDictionary'] ? $_EXTCONF['defaultDictionary'] : 'en';
 
 $TYPO3_CONF_VARS['EXTCONF'][$_EXTKEY]['plugins']['FindReplace'] = array();
 $TYPO3_CONF_VARS['EXTCONF'][$_EXTKEY]['plugins']['FindReplace']['objectReference'] = 'EXT:'.$_EXTKEY.'/extensions/FindReplace/class.tx_rtehtmlarea_findreplace.php:&tx_rtehtmlarea_findreplace';
Index: typo3/sysext/rtehtmlarea/pi1/class.tx_rtehtmlarea_pi1.php
===================================================================
--- typo3/sysext/rtehtmlarea/pi1/class.tx_rtehtmlarea_pi1.php	(révision 10446)
+++ typo3/sysext/rtehtmlarea/pi1/class.tx_rtehtmlarea_pi1.php	(copie de travail)
@@ -89,8 +89,6 @@
 		}
 		if (empty($dictionaryList)) {
 			$dictionaryList = t3lib_div::_POST('showDictionaries');
-				// Applying EM variable DEPRECATED as of TYPO3 4.3.0
-			$dictionaryList = $dictionaryList ? $dictionaryList : trim($GLOBALS['TYPO3_CONF_VARS']['EXTCONF'][$this->extKey]['plugins']['SpellChecker']['dictionaryList']);
 		}
 		$dictionaryArray = t3lib_div::trimExplode(',', $dictionaryList, 1);
 		$restrictToDictionaries = t3lib_div::_POST('restrictToDictionaries');
@@ -101,8 +99,7 @@
 			$dictionaryArray[] = 'en';
 		}
 		$this->dictionary = t3lib_div::_POST('dictionary');
-			// Applying EM variable DEPRECATED as of TYPO3 4.3.0
-		$defaultDictionary = $this->dictionary ? $this->dictionary : trim($TYPO3_CONF_VARS['EXTCONF'][$this->extKey]['plugins']['SpellChecker']['defaultDictionary']);
+		$defaultDictionary = $this->dictionary;
 		if (!$defaultDictionary || !in_array($defaultDictionary, $dictionaryArray)) {
 			$defaultDictionary = 'en';
 		}