Index: typo3/sysext/rtehtmlarea/extensions/QuickTag/class.tx_rtehtmlarea_quicktag.php
===================================================================
--- typo3/sysext/rtehtmlarea/extensions/QuickTag/class.tx_rtehtmlarea_quicktag.php	(révision 10449)
+++ typo3/sysext/rtehtmlarea/extensions/QuickTag/class.tx_rtehtmlarea_quicktag.php	(copie de travail)
@@ -53,39 +53,8 @@
 		}
 		return $available;
 	}
-
-	/**
-	 * Return JS configuration of the htmlArea plugins registered by the extension
-	 *
-	 * @param	integer		Relative id of the RTE editing area in the form
-	 *
-	 * @return string		JS configuration for registered plugins
-	 *
-	 * The returned string will be a set of JS instructions defining the configuration that will be provided to the plugin(s)
-	 * Each of the instructions should be of the form:
-	 * 	RTEarea['.$RTEcounter.']["buttons"]["button-id"]["property"] = "value";
-	 */
-	public function buildJavascriptConfiguration($RTEcounter) {
-
-		$registerRTEinJavascriptString = '';
-			// Deprecated inserttag button configuration
-		if (in_array('inserttag', $this->toolbar) && trim($this->thisConfig['hideTags'])) {
-			if (!is_array($this->thisConfig['buttons.']['inserttag.'])) {
-				$registerRTEinJavascriptString .= '
-			RTEarea['.$RTEcounter.'].buttons.inserttag = new Object();
-			RTEarea['.$RTEcounter.'].buttons.inserttag.denyTags = "'.implode(',', t3lib_div::trimExplode(',', $this->thisConfig['hideTags'], 1)).'";';
-			} elseif (!$this->thisConfig['buttons.']['inserttag.']['denyTags']) {
-				$registerRTEinJavascriptString .= '
-			RTEarea['.$RTEcounter.'].buttons.inserttag.denyTags = "'.implode(',', t3lib_div::trimExplode(',', $this->thisConfig['hideTags'], 1)).'";';
-			}
-		}
-		return $registerRTEinJavascriptString;
-	}
-
-} // end of class
-
+}
 if (defined('TYPO3_MODE') && isset($GLOBALS['TYPO3_CONF_VARS'][TYPO3_MODE]['XCLASS']['ext/rtehtmlarea/extensions/QuickTag/class.tx_rtehtmlarea_quicktag.php'])) {
 	include_once($GLOBALS['TYPO3_CONF_VARS'][TYPO3_MODE]['XCLASS']['ext/rtehtmlarea/extensions/QuickTag/class.tx_rtehtmlarea_quicktag.php']);
 }
-
 ?>
\ No newline at end of file
Index: typo3/sysext/rtehtmlarea/extensions/SpellChecker/class.tx_rtehtmlarea_spellchecker.php
===================================================================
--- typo3/sysext/rtehtmlarea/extensions/SpellChecker/class.tx_rtehtmlarea_spellchecker.php	(révision 10449)
+++ typo3/sysext/rtehtmlarea/extensions/SpellChecker/class.tx_rtehtmlarea_spellchecker.php	(copie de travail)
@@ -74,8 +74,7 @@
 			$spellCheckerMode = 'normal';
 		}
 			// Set the use of personal dictionary
-			// $this->thisConfig['enablePersonalDicts'] is DEPRECATED as of 4.3.0
-		$enablePersonalDicts = ($this->thisConfig['buttons.'][$button.'.']['enablePersonalDictionaries'] || $this->thisConfig['enablePersonalDicts']) ? ((isset($GLOBALS['BE_USER']->userTS['options.']['enablePersonalDicts']) && $GLOBALS['BE_USER']->userTS['options.']['enablePersonalDicts']) ? true : false) : false;
+		$enablePersonalDicts = $this->thisConfig['buttons.'][$button.'.']['enablePersonalDictionaries'] ? ((isset($GLOBALS['BE_USER']->userTS['options.']['enablePersonalDicts']) && $GLOBALS['BE_USER']->userTS['options.']['enablePersonalDicts']) ? true : false) : false;
 		if (t3lib_utility_PhpOptions::isSafeModeEnabled() || $this->htmlAreaRTE->is_FE()) {
 			$enablePersonalDicts = false;
 		}
Index: typo3/sysext/rtehtmlarea/extensions/TableOperations/class.tx_rtehtmlarea_tableoperations.php
===================================================================
--- typo3/sysext/rtehtmlarea/extensions/TableOperations/class.tx_rtehtmlarea_tableoperations.php	(révision 10449)
+++ typo3/sysext/rtehtmlarea/extensions/TableOperations/class.tx_rtehtmlarea_tableoperations.php	(copie de travail)
@@ -121,18 +121,6 @@
 
 			$registerRTEinJavascriptString .= '
 			RTEarea['.$RTEcounter.'].hideTableOperationsInToolbar = ' . (trim($this->thisConfig['hideTableOperationsInToolbar']) ? 'true' : 'false') . ';';
-
-				// Deprecated toggleborders button configuration
-			if (in_array('toggleborders',$this->toolbar) && $this->thisConfig['keepToggleBordersInToolbar']) {
-				if (!is_array($this->thisConfig['buttons.']['toggleborders.'])) {
-					$registerRTEinJavascriptString .= '
-			RTEarea['.$RTEcounter.'].buttons.toggleborders = new Object();
-			RTEarea['.$RTEcounter.'].buttons.toggleborders.keepInToolbar = true;';
-				} elseif (!$this->thisConfig['buttons.']['toggleborders.']['keepInToolbar']) {
-					$registerRTEinJavascriptString .= '
-			RTEarea['.$RTEcounter.'].buttons.toggleborders.keepInToolbar = true;';
-				}
-			}
 		}
 		return $registerRTEinJavascriptString;
 	}